<template>
    <div ref="slideover" class="slideover">
        <section ref="menu" class="menu">
            <div class="--margins"></div>
            <nav class="menu-list">
                <ul>
                    <li class="menu-item">
                        <router-link to="/notebook">
                            <span class="icon">
                                <app-icon size="lg" icon="sticky-note"></app-icon>
                            </span>
                            <span class="title">All Notes</span>
                        </router-link>
                    </li>
                    <li class="menu-item">
                        <div class="sub-menu">
                            <span @click="toggleOpenNotebooks" class="header-section">
                                <span class="icon">
                                    <app-icon size="lg" icon="book"></app-icon>
                                </span>
                                <span class="title">Notebooks</span>
                                <span class="down-icon">
                                    <app-icon v-if="!openNotebooks" size="lg" icon="chevron-down"></app-icon>
                                    <app-icon v-if="openNotebooks" size="lg" icon="chevron-up"></app-icon>
                                </span>
                            </span>
                            <div class="dropdown-section">
                                <transition name="dropdown-list" mode="in-out">
                                    <ul v-if="openNotebooks">
                                        <li
                                            class="sub-menu-item"
                                            @click="goToNotebook(notebook)"
                                            v-for="(notebook, index) in allNotebooks"
                                            :key="index"
                                        >
                                            <span class="icon">
                                                <app-icon icon="circle"></app-icon>
                                            </span>
                                            <span class="title">{{notebook.name}}</span>
                                        </li>
                                    </ul>
                                </transition>
                            </div>
                        </div>
                    </li>
                    <li class="menu-item">
                        <div class="sub-menu">
                            <span @click="toggleOpenTags" class="header-section">
                                <span class="icon">
                                    <app-icon size="lg" icon="tags"></app-icon>
                                </span>
                                <span class="title">Tags</span>
                                <span class="down-icon">
                                    <app-icon v-if="!openTags" size="lg" icon="chevron-down"></app-icon>
                                    <app-icon v-if="openTags" size="lg" icon="chevron-up"></app-icon>
                                </span>
                            </span>
                            <div class="dropdown-section">
                                <transition name="dropdown-list" mode="in-out">
                                    <ul v-if="openTags">
                                        <li
                                            class="sub-menu-item"
                                            @click="goToTag(tag)"
                                            v-for="(tag, index) in allTags"
                                            :key="index"
                                        >
                                            <span class="icon">
                                                <app-icon icon="circle"></app-icon>
                                            </span>
                                            <span class="title">{{tag.name}}</span>
                                        </li>
                                    </ul>
                                </transition>
                            </div>
                        </div>
                    </li>
                </ul>
            </nav>
            <div class="--margins"></div>
        </section>
        <section ref="overlay" class="overlay editor" @click="closeMenu"></section>
    </div>
</template>

<style lang="css" scoped>
.dropdown-list-enter-active,
.dropdown-list-leave-active {
    transition: all 200ms;
}
.dropdown-list-enter,
.dropdown-list-leave-to {
    opacity: 0;
    transform: translateY(30px);
}
</style>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { State } from 'vuex-class'
import { Prop, Watch } from 'vue-property-decorator'
import { offlineDB } from '@/offline/db'
import anime, { AnimeTimelineInstance, AnimeParams } from 'animejs'
import { SlideOverRefs } from '@/app/Editor/types/slideover'
import { IRoot } from '@/store/types/root'
import { ITag } from '@/store/types/tags'
import { INotebook } from '@/store/types/notebooks'

@Component
export default class SlideOverNode extends Vue {
    // Lifecycles
    mounted() {
        const { slideover, overlay, menu } = this.$refs as SlideOverRefs
        this.slideover = slideover
        this.menu = menu
        this.overlay = overlay
    }

    // Props

    @Prop() open: boolean | undefined

    // State

    @State((state: IRoot) => {
        return state.Tags.tags
    })
    allTags: ITag[] | undefined

    @State((state: IRoot) => {
        return state.Notebooks.notebooks
    })
    allNotebooks: INotebook[] | undefined

    // Data

    openNotebooks: boolean = false
    openTags: boolean = false
    slideover: Element | undefined
    menu: Element | undefined
    overlay: Element | undefined
    animationSettings: AnimeParams = {
        duration: 250,
        easing: 'cubicBezier(0.4,0.0,0.2,1)',
    }

    // Watchers
    @Watch('open')
    watchOpen(newOpenState: boolean) {
        if (newOpenState) {
            // if true
            if (this.menu && this.overlay) {
                if (this.slideover) this.slideover.classList.add('open')
                this.initStateMenu(this.menu)
                this.initStateOverlay(this.overlay)
            }
        } else {
            // if false
            if (this.menu && this.overlay) {
                this.leaveActiveMenu(this.menu)
                this.leaveActiveOverlay(this.overlay)
            }
        }
    }

    // Methods

    goToNotebook(notebook: INotebook) {
        if (notebook.id) {
            const url = `/notebook/${notebook.id}/`
            if (this.$route.fullPath !== url) this.$router.push(url)
            offlineDB.saveCurrentNotebook(notebook)
            this.closeMenu()
        }
    }

    goToTag(tag: ITag) {
        if (tag.id) {
            const url = `/tags/${tag.id}/`
            if (this.$route.fullPath !== url) this.$router.push(url)
            this.closeMenu()
        }
    }

    closeMenu() {
        this.$emit('close', false)
    }

    toggleOpenNotebooks() {
        this.openNotebooks = !this.openNotebooks
    }

    toggleOpenTags() {
        this.openTags = !this.openTags
    }

    // SPECIAL METHODS
    // Animation

    // 1. Menu

    initStateMenu(el: Element) {
        this.enterActiveMenu(el)
    }

    enterActiveMenu(el: Element) {
        anime({
            targets: this.menu,
            translateX: ['-100%', 0],
            ...this.animationSettings,
        })
    }

    leaveActiveMenu(el: Element) {
        anime({
            targets: this.menu,
            translateX: '-100%',
            complete: () => {
                if (this.slideover) this.slideover.classList.remove('open')
            },
            ...this.animationSettings,
        })
    }

    // 2. Overlay

    initStateOverlay(el: Element) {
        this.enterActiveOverlay(el)
    }

    enterActiveOverlay(el: Element) {
        anime({
            targets: this.overlay,
            opacity: 0.35,
            ...this.animationSettings,
        })
    }

    leaveActiveOverlay(el: Element) {
        anime({
            targets: this.overlay,
            opacity: 0,
            ...this.animationSettings,
        })
    }
}
</script>